<?php

namespace app\admin\model\school\help;

use think\Model;
use traits\model\SoftDelete;

class Cate extends Model
{

    use SoftDelete;

    

    // 表名
    protected $name = 'school_help_cate';
    
    // 自动写入时间戳字段
    protected $autoWriteTimestamp = 'integer';

    // 定义时间戳字段名
    protected $createTime = 'createtime';
    protected $updateTime = 'updatetime';
    protected $deleteTime = 'deletetime';

    // 追加属性
    protected $append = [
        'status_text',
        'level_num',
    ];
    

    protected static function init()
    {
        self::afterInsert(function ($row) {
            if (!$row['weigh']) {
                $pk = $row->getPk();
                $row->getQuery()->where($pk, $row[$pk])->update(['weigh' => $row[$pk]]);
            }
        });
    }

    
    public function getStatusList()
    {
        return ['1' => __('Status 1'), '2' => __('Status 2')];
    }


    public function getStatusTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['status']) ? $data['status'] : '');
        $list = $this->getStatusList();
        return isset($list[$value]) ? $list[$value] : '';
    }


    public function getLevelNumAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['id']) ? $data['id'] : '');
        if(!$value) return 0;
        $level = 0;
        while($value)
        {
            $value = $this->where('id', $value)->value('pid');
            $level++;
        }
        return $level;
    }




}
